VERSION 1.0 CLASS
BEGIN
  MultiUse = -1  'True
END
Attribute VB_Name = "REPLACEME1"
Attribute VB_Creatable = True
Attribute VB_Exposed = True
Option Explicit

Private ve$, vr$, vl$
Private SessionCallNumber&
Private IgnoreInputProperties As Boolean

Private Sub Class_Initialize()

ve = vbCrLf
vr = vbCr
vl = vbLf
SessionCallNumber = 0
web_DllOrExe = "D"

'web_IAmBack = False
'web_YouCanGo = False

'temporarily 10 seconds:
'web_ResponseTo = 10000
'web_ServerDidNotComplete = False

'Load web_frmTimer

End Sub


'mmmmmmmmmmmmmmmmmmmmmmmmmmmmmmmmmmmmmmmmmmmmmmmmmmmmmmmm
'CLASS WICH PROVIDES AN INTERFACE TO DLL
'- - ------------------------------------------------------
'     This class must be included in the dll.
'     If this class name ""InterfaceToDll"",
'     conflicts with already existing name,
'     correspondind changes should be made.
'========================================================
'
'================================================
'DESC sets properties changed by Web Browser
'     fires events    fired   by Web Browser
'     gets properties changed by VB  Application
'INPU p - array of properties, e - event
'OUTP p - array of properties
'     msg - zero-based array of 6 elements
'           msg(0) = 1 => message box happened
'                  = 0    no message
'
'Fatal exception is indicated by ExchangeData <> ""
'      in this case ExchangeData contains message
'
'invalid_session <> "" if session was unexpectably reset
'        invalid_session is a message in this case
'------------------------------------------------
Public Function ExchangeData(p, e, loaded_forms, _
       session_call_number, invalid_session, _
       msg, _
       app_terminated, _
       ignore_input_properties)

Dim ws$, w_invalid_session$, w_session_number&

web_MsgCalled = 0
If msg(0) <> 0 Then
   web_ResponseToMsgBoxTo = msg(0)
End If

invalid_session = ""

w_invalid_session = "Session Visit Number '" & _
   session_call_number & "' is invalid." & ve & _
   "The Visit Number " & SessionCallNumber & " is expected." & ve & _
   "Please call from the correct browser's page or " & ve & _
   "restart the Session." & ve & _
   "Please be sure that cookies are enabled and browser is set correctly."

On Error Resume Next
w_session_number = CLng(session_call_number)
If Err.Number > 0 Then
   invalid_session = w_invalid_session
   Exit Function
End If

If w_session_number < 0 Then
   invalid_session = w_invalid_session
   Exit Function
End If

If w_session_number < SessionCallNumber Then
   invalid_session = w_invalid_session & ve & ve & _
     "Your session may be expired which" & ve & _
     "happens after some inactivity time." & ve & _
     "Sorry for any inconvenience this setting may be caused."
   Exit Function
End If


SessionCallNumber = SessionCallNumber + 1

'Hope this never happens:
If 2000000000 < SessionCallNumber Then
   SessionCallNumber = 1
End If

session_call_number = CStr(SessionCallNumber)

On Error GoTo HE

mic_BuildLoadedForms


IgnoreInputProperties = ignore_input_properties
',#]REPLACEME2

loaded_forms = LoadedForms

app_terminated = 0
If web_InformTerminationToClient Then
   msg(1) = "Application Terminated."
   GoTo TerminateAndExit2
End If

If 0 < web_MsgCalled Then
   'MsgBox has been called
   msg(0) = web_MsgCalled
   msg(1) = web_MsgMessage
   msg(2) = CStr(web_MsgButtons)
   msg(3) = web_MsgTitle
   msg(4) = web_MsgHelpFile
   msg(5) = CStr(web_MsgContext)
   web_MsgCalled = 0
   web_MsgMessage = ""
   web_MsgButtons = 0
   web_MsgTitle = ""
   web_MsgHelpFile = ""
   web_MsgContext = 0
End If

Exit Function

TerminateAndExit:
      web_DestroyAllForms
TerminateAndExit2:
      msg(0) = 1  'msg(1) must be already set;
      app_terminated = -1
      Exit Function


HE:   msg(1) = _
        "Exception " & Err.Number & " " & _
        Err.Description & ve & _
        "in ExchangeData method at event " _
        & CStr(e)
      Resume xTerminateAndExit

xTerminateAndExit:
      On Error Resume Next
      GoTo TerminateAndExit

End Function


'micro helper:
Private Function mic_IsLoaded(FrmName$) As Boolean
 If InStr(ve & UCase(LoadedForms), ve & UCase(FrmName) & ve) > 0 Then
    mic_IsLoaded = True
 Else
    mic_IsLoaded = False
 End If
End Function

